searchNodes=[{"doc":"JSONAPIPlug context This defines a struct for storing configuration and request data. JSONAPIPlug.Plug populates its attributes by means of a number of other plug modules used to parse and validate requests and stores it in the Plug.Conn private assings under the jsonapi_plug key.","ref":"JSONAPIPlug.html","title":"JSONAPIPlug","type":"module"},{"doc":"JSON:API MIME type Returns the JSON:API MIME type.","ref":"JSONAPIPlug.html#mime_type/0","title":"JSONAPIPlug.mime_type/0","type":"function"},{"doc":"Recase resource fields Changes the case of resource field names to the specified case, ignoring underscores or dashes that are not between letters/numbers. Examples iex&gt; recase ( &quot;top_posts&quot; , :camelize ) &quot;topPosts&quot; iex&gt; recase ( :top_posts , :camelize ) &quot;topPosts&quot; iex&gt; recase ( &quot;_top_posts&quot; , :camelize ) &quot;_topPosts&quot; iex&gt; recase ( &quot;_top__posts_&quot; , :camelize ) &quot;_top__posts_&quot; iex&gt; recase ( &quot;&quot; , :camelize ) &quot;&quot; iex&gt; recase ( &quot;top_posts&quot; , :dasherize ) &quot;top-posts&quot; iex&gt; recase ( &quot;_top_posts&quot; , :dasherize ) &quot;_top-posts&quot; iex&gt; recase ( &quot;_top__posts_&quot; , :dasherize ) &quot;_top__posts_&quot; iex&gt; recase ( &quot;top-posts&quot; , :underscore ) &quot;top_posts&quot; iex&gt; recase ( :top_posts , :underscore ) &quot;top_posts&quot; iex&gt; recase ( &quot;-top-posts&quot; , :underscore ) &quot;-top_posts&quot; iex&gt; recase ( &quot;-top--posts-&quot; , :underscore ) &quot;-top--posts-&quot; iex&gt; recase ( &quot;corgiAge&quot; , :underscore ) &quot;corgi_age&quot;","ref":"JSONAPIPlug.html#recase/2","title":"JSONAPIPlug.recase/2","type":"function"},{"doc":"","ref":"JSONAPIPlug.html#t:case/0","title":"JSONAPIPlug.case/0","type":"type"},{"doc":"","ref":"JSONAPIPlug.html#t:t/0","title":"JSONAPIPlug.t/0","type":"type"},{"doc":"JSON:API API Configuration You can define an API by &quot;use-ing&quot; JSONAPIPlug.API in your API module: defmodule MyApp.API do use JSONAPIPlug.API , otp_app : :my_app end API module configuration can be customized via your application configuration: config :my_app , MyApp.API , namespace : &quot;api&quot; , case : :dasherize See options/0 for all available configuration options.","ref":"JSONAPIPlug.API.html","title":"JSONAPIPlug.API","type":"module"},{"doc":"Retrieve a configuration option Retrieves an API configuration option value, with fallback to a default value in case the configuration option is not present.","ref":"JSONAPIPlug.API.html#get_config/3","title":"JSONAPIPlug.API.get_config/3","type":"function"},{"doc":"API configuration options: :case - This option controls how your API's field names will be cased. The current JSON:API Specification v1.0 recommends dasherizing (e.g. &quot;favorite-color&quot;: &quot;blue&quot; ), while the upcoming JSON:API Specification v1.1 recommends camelCase (e.g. &quot;favoriteColor&quot;: &quot;blue&quot; ). The default value is :camelize . :client_generated_ids ( boolean/0 ) - Enable support for Client-Generated IDs. When enabled, the resources received in requests are supposed to contain a valid 'id'. The default value is false . :host ( String.t/0 ) - Hostname used for link generation instead of deriving it from the connection. :namespace ( String.t/0 ) - Namespace for all resources in your API. if you want your resources to live under &quot;.../api/v1&quot;, pass namespace: &quot;api/v1&quot; . :normalizer ( atom/0 ) - Normalizer for transformation of JSON:API document to and from user data. The default value is JSONAPIPlug.Normalizer.Ecto . :query_parsers ( keyword/0 ) - Parsers for transformation of JSON:API request query parameters to user data. The default value is [fields: JSONAPIPlug.QueryParser.Ecto.Fields, filter: JSONAPIPlug.QueryParser.Filter, include: JSONAPIPlug.QueryParser.Ecto.Include, page: JSONAPIPlug.QueryParser.Page, sort: JSONAPIPlug.QueryParser.Ecto.Sort] . :fields ( atom/0 ) - Fields query parameter parser. The default value is JSONAPIPlug.QueryParser.Ecto.Fields . :filter ( atom/0 ) - Filter query parameter parser. The default value is JSONAPIPlug.QueryParser.Filter . :include ( atom/0 ) - Include query parameter parser. The default value is JSONAPIPlug.QueryParser.Ecto.Include . :page ( atom/0 ) - Page query parameter parser. The default value is JSONAPIPlug.QueryParser.Page . :sort ( atom/0 ) - Sort query parameter parser. The default value is JSONAPIPlug.QueryParser.Ecto.Sort . :pagination ( atom/0 ) - A module adopting the JSONAPIPlug.Pagination behaviour for pagination. The default value is nil . :port ( pos_integer/0 ) - Port used for link generation instead of deriving it from the connection. :scheme - Scheme used for link generation instead of deriving it from the connection. :version - JSON:API version advertised in the document The default value is :&quot;1.0&quot; .","ref":"JSONAPIPlug.API.html#t:options/0","title":"JSONAPIPlug.API.options/0","type":"type"},{"doc":"","ref":"JSONAPIPlug.API.html#t:t/0","title":"JSONAPIPlug.API.t/0","type":"type"},{"doc":"JSON:API Document This module defines the structure of a JSON:API document and functions that handle serialization and deserialization. This also handles validation of JSON:API documents. https://jsonapi.org/format/#document-structure","ref":"JSONAPIPlug.Document.html","title":"JSONAPIPlug.Document","type":"module"},{"doc":"Deserialize JSON:API Document Takes a map representing a JSON:API Document as input, validates it and parses it into a t/0 struct.","ref":"JSONAPIPlug.Document.html#deserialize/1","title":"JSONAPIPlug.Document.deserialize/1","type":"function"},{"doc":"Serialize a Document struct representing a JSON:API Document Takes a t/0 struct representing a JSON:API Document as input, validates it and returns the struct if valid.","ref":"JSONAPIPlug.Document.html#serialize/1","title":"JSONAPIPlug.Document.serialize/1","type":"function"},{"doc":"JSON:API Primary Data https://jsonapi.org/format/#document-top-level","ref":"JSONAPIPlug.Document.html#t:data/0","title":"JSONAPIPlug.Document.data/0","type":"type"},{"doc":"JSON:API Errors https://jsonapi.org/format/#errors","ref":"JSONAPIPlug.Document.html#t:errors/0","title":"JSONAPIPlug.Document.errors/0","type":"type"},{"doc":"JSON:API Included Resources https://jsonapi.org/format/#document-compound-documents","ref":"JSONAPIPlug.Document.html#t:included/0","title":"JSONAPIPlug.Document.included/0","type":"type"},{"doc":"JSON:API Object https://jsonapi.org/format/#document-jsonapi-object","ref":"JSONAPIPlug.Document.html#t:jsonapi/0","title":"JSONAPIPlug.Document.jsonapi/0","type":"type"},{"doc":"JSON:API Links https://jsonapi.org/format/#document-links","ref":"JSONAPIPlug.Document.html#t:links/0","title":"JSONAPIPlug.Document.links/0","type":"type"},{"doc":"JSON:API Meta Information https://jsonapi.org/format/#document-meta","ref":"JSONAPIPlug.Document.html#t:meta/0","title":"JSONAPIPlug.Document.meta/0","type":"type"},{"doc":"","ref":"JSONAPIPlug.Document.html#t:payload/0","title":"JSONAPIPlug.Document.payload/0","type":"type"},{"doc":"JSON:API Document https://jsonapi.org/format/#document-structure","ref":"JSONAPIPlug.Document.html#t:t/0","title":"JSONAPIPlug.Document.t/0","type":"type"},{"doc":"","ref":"JSONAPIPlug.Document.html#t:value/0","title":"JSONAPIPlug.Document.value/0","type":"type"},{"doc":"Implements validation and parsing of JSON:API requests This plug handles the specification defined JSON:API request body and query parameters ( fields , filter , include , page and sort ). Usage Add this plug to your plug pipeline/controller like this: plug JSONAPIPlug.Plug , api : MyApp.API , resource : MyApp.MyResource If your connection receives a valid JSON:API request this plug will parse it into a JSONAPIPlug struct that will be stored in the Plug.Conn private assign :jsonapi_plug . The final Plug.Conn struct will look similar to the following: % Plug.Conn { ... body_params : %{ ... } , params : %{ &quot;data&quot; =&gt; ... } , private : %{ ... jsonapi_plug : % JSONAPIPlug { api : MyApp.API , fields : ... , # Defaults to a map of field names by type. filter : ... , # Defaults to the query parameter value. include : ... , # Defaults to Ecto preload format. page : ... , # Defaults to the query parameter value. params : ... , # Defaults to Ecto normalized data. sort : ... , # Defaults to Ecto order_by format. resource : MyApp.MyResource } ... } ... } You can then use the contents of the struct to load data and call JSONAPIPlug.Resource.render/5 or the render function generated by use JSONAPIPlug.Resource to generate responses and render them. Customizing default behaviour Body parameters By default, body parameters are transformed into a format that is compatible with attrs for Ecto.Changeset to perform inserts/updates of Ecto.Schema modules. However, you can transform the JSON:API document in any format you want by writing your own module adopting the JSONAPIPlug.Normalizer behaviour and configuring it through JSONAPIPlug.API configuration. Query parameters The JSON:API fields and include query parameters format is defined by the specification. The default implementation accepts the specification format and converts it to data usable as select and preload options to Ecto.Repo functions. The JSON:API sort query parameter format is not defined, however the specification suggests to use a format for encoding sorting by attribute names with an optional - prefix to invert ordering direction. The default implementation accepts the suggested format and converts it to usable as order_by option to Ecto.Repo functions. The JSON:API filter and page query parameters format is not defined by the JSON:API specification, therefore the default implementation just copies the value of the query parameters in JSONAPIPlug . You can transform data in any format you want for any of these parameters by implementing a module adopting the JSONAPIPlug.QueryParser behaviour and configuring it through JSONAPIPlug.API configuration.","ref":"JSONAPIPlug.Plug.html","title":"JSONAPIPlug.Plug","type":"module"},{"doc":"Callback implementation for Plug.call/2 .","ref":"JSONAPIPlug.Plug.html#call/2","title":"JSONAPIPlug.Plug.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1 .","ref":"JSONAPIPlug.Plug.html#init/1","title":"JSONAPIPlug.Plug.init/1","type":"function"},{"doc":"Options: :api ( atom/0 ) - Required. A module use-ing JSONAPIPlug.API to provide configuration :resource ( atom/0 ) - Required. The JSONAPIPlug.Resource used to parse the request.","ref":"JSONAPIPlug.Plug.html#t:options/0","title":"JSONAPIPlug.Plug.options/0","type":"type"},{"doc":"A Resource is simply a module that describes how to render your data as JSON:API resources. You can implement a resource by &quot;use-ing&quot; the JSONAPIPlug.Resource module, which is recommeded, or by adopting the JSONAPIPlug.Resource behaviour and implementing all of the callback functions: defmodule MyApp.UsersResource do use JSONAPIPlug.Resource , type : &quot;user&quot; , attributes : [ :name , :surname , :username ] end See options/0 for all available options you can pass to use JSONAPIPlug.Resource . You can now call UsersResource.render(&quot;show.json&quot;, %{data: user}) or Resource.render(UsersResource, conn, user) to render a valid JSON:API document from your data. If you use phoenix, you can use: render ( conn , &quot;show.json&quot; , %{ data : user } ) in your controller functions to render the document in the same way. Attributes By default, the resulting JSON document consists of resources taken from your data. Only resource attributes defined on the resource will be (de)serialized. You can customize how attributes are handled by passing a keyword list of options: defmodule MyApp.UsersResource do use JSONAPIPlug.Resource , type : &quot;user&quot; , attributes : [ username : nil , fullname : [ deserialize : false , serialize : &amp; fullname / 2 ] ] defp fullname ( resource , conn ) , do : &quot; \#{ resouce . first_name } \#{ resource . last_name } &quot; end In this example we are defining a computed attribute by passing the serialize option a function reference. Serialization functions take resource and conn as arguments and return the attribute value to be serialized. The deserialize option set to false makes sure the attribute is not deserialized when receiving a request. Relationships Relationships are defined by passing the relationships option to use JSONAPIPlug.Resource . defmodule MyApp.PostResource do use JSONAPIPlug.Resource , type : &quot;post&quot; , attributes : [ :text , :body ] relationships : [ author : [ resource : MyApp.UsersResource ] , comments : [ many : true , resource : MyApp.CommentsResource ] ] end defmodule MyApp.CommentsResource do alias MyApp.UsersResource use JSONAPIPlug.Resource , type : &quot;comment&quot; , attributes : [ :text ] relationships : [ post : [ resource : MyApp.PostResource ] ] end When requesting GET /posts?include=author , if the author key is present on the data you pass from the controller it will appear in the included section of the JSON:API response. Links When rendering resource links, the default behaviour is to is to derive values for host , port and scheme from the connection. If you need to use different values for some reason, you can override them using JSONAPIPlug.API configuration options in your api configuration: config :my_app , MyApp.API , host : &quot;adifferenthost.com&quot;","ref":"JSONAPIPlug.Resource.html","title":"JSONAPIPlug.Resource","type":"behaviour"},{"doc":"Resource attributes Returns the keyword list of resource attributes for the resource.","ref":"JSONAPIPlug.Resource.html#c:attributes/0","title":"JSONAPIPlug.Resource.attributes/0","type":"callback"},{"doc":"Field option Returns the name of the attribute or relationship for the field definition.","ref":"JSONAPIPlug.Resource.html#field_name/1","title":"JSONAPIPlug.Resource.field_name/1","type":"function"},{"doc":"Field option Returns the value of the attribute or relationship option for the field definition.","ref":"JSONAPIPlug.Resource.html#field_option/2","title":"JSONAPIPlug.Resource.field_option/2","type":"function"},{"doc":"","ref":"JSONAPIPlug.Resource.html#field_option/3","title":"JSONAPIPlug.Resource.field_option/3","type":"function"},{"doc":"Related Resource based on JSON:API type Returns the resource used to handle relationships of the requested type by the passed resource.","ref":"JSONAPIPlug.Resource.html#for_related_type/2","title":"JSONAPIPlug.Resource.for_related_type/2","type":"function"},{"doc":"Resource Id Attribute Returns the attribute used to fetch resource ids for resources by the resource.","ref":"JSONAPIPlug.Resource.html#c:id_attribute/0","title":"JSONAPIPlug.Resource.id_attribute/0","type":"callback"},{"doc":"Resource links Returns the resource links to be returned for resources by the resource.","ref":"JSONAPIPlug.Resource.html#c:links/2","title":"JSONAPIPlug.Resource.links/2","type":"callback"},{"doc":"Resource meta Returns the resource meta to be returned for resources by the resource.","ref":"JSONAPIPlug.Resource.html#c:meta/2","title":"JSONAPIPlug.Resource.meta/2","type":"callback"},{"doc":"Resource normalizer Returns the resource normalizer for resources by the resource.","ref":"JSONAPIPlug.Resource.html#c:normalizer/0","title":"JSONAPIPlug.Resource.normalizer/0","type":"callback"},{"doc":"Resource path Returns the path to prepend to resources for the resource.","ref":"JSONAPIPlug.Resource.html#c:path/0","title":"JSONAPIPlug.Resource.path/0","type":"callback"},{"doc":"Resource relationships Returns the keyword list of resource relationships for the resource.","ref":"JSONAPIPlug.Resource.html#c:relationships/0","title":"JSONAPIPlug.Resource.relationships/0","type":"callback"},{"doc":"Render JSON:API response Renders the JSON:API response for the specified Resource.","ref":"JSONAPIPlug.Resource.html#render/5","title":"JSONAPIPlug.Resource.render/5","type":"function"},{"doc":"Resource Type Returns the Resource Type of resources for the resource.","ref":"JSONAPIPlug.Resource.html#c:type/0","title":"JSONAPIPlug.Resource.type/0","type":"callback"},{"doc":"Generates the resource link Generates the resource link for a resource.","ref":"JSONAPIPlug.Resource.html#url_for/3","title":"JSONAPIPlug.Resource.url_for/3","type":"function"},{"doc":"Generate relationships link Generates the relationships link for a resource.","ref":"JSONAPIPlug.Resource.html#url_for_relationship/4","title":"JSONAPIPlug.Resource.url_for_relationship/4","type":"function"},{"doc":"Attribute options :name ( atom/0 ) - Maps the resource attribute name to the given key. :serialize - Controls attribute serialization. Can be either a boolean (do/don't serialize) or a function reference returning the attribute value to be serialized for full control. The default value is true . :deserialize - Controls attribute deserialization. Can be either a boolean (do/don't deserialize) or a function reference returning the attribute value to be deserialized for full control. The default value is true .","ref":"JSONAPIPlug.Resource.html#t:attribute_options/0","title":"JSONAPIPlug.Resource.attribute_options/0","type":"type"},{"doc":"Resource attributes A keyword list composed of attribute names and their options","ref":"JSONAPIPlug.Resource.html#t:attributes/0","title":"JSONAPIPlug.Resource.attributes/0","type":"type"},{"doc":"Resource data Resource data is either a resource or a list of resources","ref":"JSONAPIPlug.Resource.html#t:data/0","title":"JSONAPIPlug.Resource.data/0","type":"type"},{"doc":"","ref":"JSONAPIPlug.Resource.html#t:field/0","title":"JSONAPIPlug.Resource.field/0","type":"type"},{"doc":"Resource field name The name of a Resource field (attribute or relationship)","ref":"JSONAPIPlug.Resource.html#t:field_name/0","title":"JSONAPIPlug.Resource.field_name/0","type":"type"},{"doc":"Resource meta A free form map containing metadata to be rendered","ref":"JSONAPIPlug.Resource.html#t:meta/0","title":"JSONAPIPlug.Resource.meta/0","type":"type"},{"doc":"Resource options :attributes - Resource attributes. This will be used to (de)serialize requests/responses: :name ( atom/0 ) - Maps the resource attribute name to the given key. :serialize - Controls attribute serialization. Can be either a boolean (do/don't serialize) or a function reference returning the attribute value to be serialized for full control. The default value is true . :deserialize - Controls attribute deserialization. Can be either a boolean (do/don't deserialize) or a function reference returning the attribute value to be deserialized for full control. The default value is true . The default value is [] . :id_attribute ( atom/0 ) - Attribute on your data to be used as the JSON:API resource id. The default value is :id . :path ( String.t/0 ) - A custom path to be used for the resource. Defaults to the resource type. :relationships ( keyword/0 ) - Resource relationships. This will be used to (de)serialize requests/responses The default value is [] . :name ( atom/0 ) - Maps the resource relationship name to the given key. :many ( boolean/0 ) - Specifies a to many relationship. The default value is false . :resource ( atom/0 ) - Required. Specifies the resource to be used to serialize the relationship :type ( String.t/0 ) - Required. Resource type. To be used as the JSON:API resource type value","ref":"JSONAPIPlug.Resource.html#t:options/0","title":"JSONAPIPlug.Resource.options/0","type":"type"},{"doc":"Relationship options :name ( atom/0 ) - Maps the resource relationship name to the given key. :many ( boolean/0 ) - Specifies a to many relationship. The default value is false . :resource ( atom/0 ) - Required. Specifies the resource to be used to serialize the relationship","ref":"JSONAPIPlug.Resource.html#t:relationship_options/0","title":"JSONAPIPlug.Resource.relationship_options/0","type":"type"},{"doc":"Resource attributes A keyword list composed of relationship names and their options","ref":"JSONAPIPlug.Resource.html#t:relationships/0","title":"JSONAPIPlug.Resource.relationships/0","type":"type"},{"doc":"Resource data User data representing a single resource","ref":"JSONAPIPlug.Resource.html#t:resource/0","title":"JSONAPIPlug.Resource.resource/0","type":"type"},{"doc":"Resource module A Module adopting the JSONAPIPlug.Resource behaviour","ref":"JSONAPIPlug.Resource.html#t:t/0","title":"JSONAPIPlug.Resource.t/0","type":"type"},{"doc":"JSON:API Error Object https://jsonapi.org/format/#error-objects","ref":"JSONAPIPlug.Document.ErrorObject.html","title":"JSONAPIPlug.Document.ErrorObject","type":"module"},{"doc":"","ref":"JSONAPIPlug.Document.ErrorObject.html#deserialize/1","title":"JSONAPIPlug.Document.ErrorObject.deserialize/1","type":"function"},{"doc":"","ref":"JSONAPIPlug.Document.ErrorObject.html#serialize/1","title":"JSONAPIPlug.Document.ErrorObject.serialize/1","type":"function"},{"doc":"","ref":"JSONAPIPlug.Document.ErrorObject.html#t:t/0","title":"JSONAPIPlug.Document.ErrorObject.t/0","type":"type"},{"doc":"JSON:API Document JSON:API Object","ref":"JSONAPIPlug.Document.JSONAPIObject.html","title":"JSONAPIPlug.Document.JSONAPIObject","type":"module"},{"doc":"","ref":"JSONAPIPlug.Document.JSONAPIObject.html#deserialize/1","title":"JSONAPIPlug.Document.JSONAPIObject.deserialize/1","type":"function"},{"doc":"","ref":"JSONAPIPlug.Document.JSONAPIObject.html#t:t/0","title":"JSONAPIPlug.Document.JSONAPIObject.t/0","type":"type"},{"doc":"","ref":"JSONAPIPlug.Document.JSONAPIObject.html#t:version/0","title":"JSONAPIPlug.Document.JSONAPIObject.version/0","type":"type"},{"doc":"JSON:API Link Object https://jsonapi.org/format/#document-links","ref":"JSONAPIPlug.Document.LinkObject.html","title":"JSONAPIPlug.Document.LinkObject","type":"module"},{"doc":"","ref":"JSONAPIPlug.Document.LinkObject.html#deserialize/1","title":"JSONAPIPlug.Document.LinkObject.deserialize/1","type":"function"},{"doc":"","ref":"JSONAPIPlug.Document.LinkObject.html#serialize/1","title":"JSONAPIPlug.Document.LinkObject.serialize/1","type":"function"},{"doc":"","ref":"JSONAPIPlug.Document.LinkObject.html#t:t/0","title":"JSONAPIPlug.Document.LinkObject.t/0","type":"type"},{"doc":"JSON:API Relationship Object https://jsonapi.org/format/#document-resource-object-relationships","ref":"JSONAPIPlug.Document.RelationshipObject.html","title":"JSONAPIPlug.Document.RelationshipObject","type":"module"},{"doc":"","ref":"JSONAPIPlug.Document.RelationshipObject.html#deserialize/1","title":"JSONAPIPlug.Document.RelationshipObject.deserialize/1","type":"function"},{"doc":"","ref":"JSONAPIPlug.Document.RelationshipObject.html#t:links/0","title":"JSONAPIPlug.Document.RelationshipObject.links/0","type":"type"},{"doc":"","ref":"JSONAPIPlug.Document.RelationshipObject.html#t:t/0","title":"JSONAPIPlug.Document.RelationshipObject.t/0","type":"type"},{"doc":"JSON:API Resource Identifier object https://jsonapi.org/format/#document-resource-object-linkage","ref":"JSONAPIPlug.Document.ResourceIdentifierObject.html","title":"JSONAPIPlug.Document.ResourceIdentifierObject","type":"module"},{"doc":"","ref":"JSONAPIPlug.Document.ResourceIdentifierObject.html#deserialize/1","title":"JSONAPIPlug.Document.ResourceIdentifierObject.deserialize/1","type":"function"},{"doc":"","ref":"JSONAPIPlug.Document.ResourceIdentifierObject.html#t:t/0","title":"JSONAPIPlug.Document.ResourceIdentifierObject.t/0","type":"type"},{"doc":"JSON:API Resource Object https://jsonapi.org/format/#resource_object-resource-objects","ref":"JSONAPIPlug.Document.ResourceObject.html","title":"JSONAPIPlug.Document.ResourceObject","type":"module"},{"doc":"","ref":"JSONAPIPlug.Document.ResourceObject.html#deserialize/1","title":"JSONAPIPlug.Document.ResourceObject.deserialize/1","type":"function"},{"doc":"","ref":"JSONAPIPlug.Document.ResourceObject.html#serialize/1","title":"JSONAPIPlug.Document.ResourceObject.serialize/1","type":"function"},{"doc":"","ref":"JSONAPIPlug.Document.ResourceObject.html#t:id/0","title":"JSONAPIPlug.Document.ResourceObject.id/0","type":"type"},{"doc":"","ref":"JSONAPIPlug.Document.ResourceObject.html#t:t/0","title":"JSONAPIPlug.Document.ResourceObject.t/0","type":"type"},{"doc":"","ref":"JSONAPIPlug.Document.ResourceObject.html#t:type/0","title":"JSONAPIPlug.Document.ResourceObject.type/0","type":"type"},{"doc":"Provides content type negotiation by validating the content-type and accept headers. The proper jsonapi.org content type is application/vnd.api+json as per the specification .","ref":"JSONAPIPlug.Plug.ContentTypeNegotiation.html","title":"JSONAPIPlug.Plug.ContentTypeNegotiation","type":"module"},{"doc":"Plug for parsing the JSON:API Document in requests It parses the JSON:API document in the request body to a JSONAPIPlug.Document struct, notmalizes it and stores params in the Plug.Conn private assigns for later use.","ref":"JSONAPIPlug.Plug.Params.html","title":"JSONAPIPlug.Plug.Params","type":"module"},{"doc":"JSON:API Query Paramter parser plug Plug for parsing a JSON:API query parameter via a JSONAPI.QueryParser implementation. It takes an atom corresponding to the query parameter name to parse as its only option and stores the returned value in the JSONAPIPlug struct stored in Plug.Conn private assigns under the jsonapi_plug key.","ref":"JSONAPIPlug.Plug.QueryParam.html","title":"JSONAPIPlug.Plug.QueryParam","type":"module"},{"doc":"Plug for setting the response content type Registers a before send function that sets the JSON:API content type on responses unless a response content type has already been set on the connection.","ref":"JSONAPIPlug.Plug.ResponseContentType.html","title":"JSONAPIPlug.Plug.ResponseContentType","type":"module"},{"doc":"JSON:API Document normalizer implementation for Ecto Translating JSON:API resources to and from an Ecto friendly format in conn params. Deserialization produces attributes and relationships in a way that directly translates to attributes that can be passed to an Ecto.Changeset for validation and later to Ecto.Repo for database operations.","ref":"JSONAPIPlug.Normalizer.Ecto.html","title":"JSONAPIPlug.Normalizer.Ecto","type":"module"},{"doc":"JSON:API 'fields' query parameter parser implementation for Ecto Expects include parameter to in the JSON:API fields format and converts the specification format to a map of fields list format for ease of use with select option to Ecto.Repo functions.","ref":"JSONAPIPlug.QueryParser.Ecto.Fields.html","title":"JSONAPIPlug.QueryParser.Ecto.Fields","type":"module"},{"doc":"JSON:API 'include' query parameter parser implementation for Ecto Expects include parameter to be in the JSON:API include format and converts them to Ecto preload optio to Ecto.Repo functions.","ref":"JSONAPIPlug.QueryParser.Ecto.Include.html","title":"JSONAPIPlug.QueryParser.Ecto.Include","type":"module"},{"doc":"JSON:API 'sort' query parameter parser implementation for Ecto Expects sort parameters to be in the recommended JSON:API sort format and converts them to Ecto order_by format for ease of use.","ref":"JSONAPIPlug.QueryParser.Ecto.Sort.html","title":"JSONAPIPlug.QueryParser.Ecto.Sort","type":"module"},{"doc":"JSON:API 'filter' query parameter parser Since the specification does not define the format for the JSON:API filter parameter, the default implementation just returns the value of 'filter' as is.","ref":"JSONAPIPlug.QueryParser.Filter.html","title":"JSONAPIPlug.QueryParser.Filter","type":"module"},{"doc":"JSON:API 'page' query parameter parser Since the specification does not define the format for the JSON:API page parameter, the default implementation just returns the value of 'page' as is.","ref":"JSONAPIPlug.QueryParser.Page.html","title":"JSONAPIPlug.QueryParser.Page","type":"module"},{"doc":"Transforms user data to and from a JSON:API Document. The default implementation transforms JSON:API documents in requests to an ecto friendly format and expects Ecto.Schema instances when rendering data in responses. The data it produces is stored under the :params key of the JSONAPIPlug struct that will be stored in the Plug.Conn private assign :jsonapi_plug . You can customize normalization to convert your application data to and from the JSONAPIPlug.Document data structure by providing an implementation of the JSONAPIPlug.Normalizer behaviour. defmodule MyApp.API.Normalizer ... @behaviour JSONAPIPlug.Normalizer ... end and by configuring it in your api configuration: config :my_app , MyApp.API , normalizer : MyApp.API.Normalizer You can return an error during parsing by raising JSONAPIPlug.Exceptions.InvalidDocument at any point in your normalizer code.","ref":"JSONAPIPlug.Normalizer.html","title":"JSONAPIPlug.Normalizer","type":"behaviour"},{"doc":"Transforms a JSON:API Document user data","ref":"JSONAPIPlug.Normalizer.html#denormalize/3","title":"JSONAPIPlug.Normalizer.denormalize/3","type":"function"},{"doc":"","ref":"JSONAPIPlug.Normalizer.html#c:denormalize_attribute/3","title":"JSONAPIPlug.Normalizer.denormalize_attribute/3","type":"callback"},{"doc":"","ref":"JSONAPIPlug.Normalizer.html#c:denormalize_relationship/4","title":"JSONAPIPlug.Normalizer.denormalize_relationship/4","type":"callback"},{"doc":"Transforms user data into a JSON:API Document","ref":"JSONAPIPlug.Normalizer.html#normalize/5","title":"JSONAPIPlug.Normalizer.normalize/5","type":"function"},{"doc":"","ref":"JSONAPIPlug.Normalizer.html#c:normalize_attribute/2","title":"JSONAPIPlug.Normalizer.normalize_attribute/2","type":"callback"},{"doc":"","ref":"JSONAPIPlug.Normalizer.html#c:resource_params/0","title":"JSONAPIPlug.Normalizer.resource_params/0","type":"callback"},{"doc":"","ref":"JSONAPIPlug.Normalizer.html#t:params/0","title":"JSONAPIPlug.Normalizer.params/0","type":"type"},{"doc":"","ref":"JSONAPIPlug.Normalizer.html#t:t/0","title":"JSONAPIPlug.Normalizer.t/0","type":"type"},{"doc":"","ref":"JSONAPIPlug.Normalizer.html#t:value/0","title":"JSONAPIPlug.Normalizer.value/0","type":"type"},{"doc":"JSON:API Pagination strategy https://jsonapi.org/format/#fetching-pagination Pagination links can be generated by implementing a module conforming to the JSONAPIPlug.Pagination behavior and configuring the pagination of your API module: defmodule MyApp.MyController do plug JSONAPIPlug.Plug , api : MyApp.MyApi , resource : MyApp.MyResource end config :my_app , MyApp.API , pagination : MyApp.MyPagination Actual pagination needs to be handled by your application and is outside the scope of this library. Links can be generated using the JSONAPIPlug.page information stored in the connection jsonapi_plug private field and by passing additional information to your pagination module by passing options from your controller. See the tests for an example implementation of page based pagination strategy.","ref":"JSONAPIPlug.Pagination.html","title":"JSONAPIPlug.Pagination","type":"behaviour"},{"doc":"","ref":"JSONAPIPlug.Pagination.html#c:paginate/5","title":"JSONAPIPlug.Pagination.paginate/5","type":"callback"},{"doc":"","ref":"JSONAPIPlug.Pagination.html#url_for/4","title":"JSONAPIPlug.Pagination.url_for/4","type":"function"},{"doc":"","ref":"JSONAPIPlug.Pagination.html#t:link/0","title":"JSONAPIPlug.Pagination.link/0","type":"type"},{"doc":"","ref":"JSONAPIPlug.Pagination.html#t:links/0","title":"JSONAPIPlug.Pagination.links/0","type":"type"},{"doc":"","ref":"JSONAPIPlug.Pagination.html#t:options/0","title":"JSONAPIPlug.Pagination.options/0","type":"type"},{"doc":"","ref":"JSONAPIPlug.Pagination.html#t:params/0","title":"JSONAPIPlug.Pagination.params/0","type":"type"},{"doc":"","ref":"JSONAPIPlug.Pagination.html#t:t/0","title":"JSONAPIPlug.Pagination.t/0","type":"type"},{"doc":"Parses a JSON:API query parameter to a user defined format. You can implement a custom format for JSON:API query parameters that do not define a standard format: filter, page and sort. To customize the default parser implement a module adopting the JSONAPIPlug.QueryParser behaviour for your sort format: defmodule MyApp.API.QueryParsers.Sort do ... @behaviour JSONAPIPlug.QueryParser # Transforms the query parameter value to a user defined format @impl JSONAPIPlug.QueryParser def parse ( jsonapi_plug , sort ) do ... my sort query parameter parsing logic ... end end and configure it in your API configuration under the parsers key. config :my_app , MyApp.API , parsers : [ filter : MyApp.API.QueryParser.Filter , page : MyApp.API.QueryParser.Page , sort : MyApp.API.QueryParser.Sort ] The parsers take the query parameter value as input and its return value is placed under an attribute with the same name as the query parameter in the JSONAPIPlug structure in the conn private assigns so that you can retrieve it and use it in your application logic. You can return a standard JSON:API error to the client by raising JSONAPIPlug.Exceptions.InvalidQuery exception at any point in your parser code.","ref":"JSONAPIPlug.QueryParser.html","title":"JSONAPIPlug.QueryParser","type":"behaviour"},{"doc":"Transforms the value of the JSON:API 'filter' query parameter","ref":"JSONAPIPlug.QueryParser.html#c:parse/2","title":"JSONAPIPlug.QueryParser.parse/2","type":"callback"},{"doc":"Defines a generic exception for when an invalid document is received.","ref":"JSONAPIPlug.Exceptions.InvalidDocument.html","title":"JSONAPIPlug.Exceptions.InvalidDocument","type":"exception"},{"doc":"Defines a generic exception for when an invalid header is received.","ref":"JSONAPIPlug.Exceptions.InvalidHeader.html","title":"JSONAPIPlug.Exceptions.InvalidHeader","type":"exception"},{"doc":"Defines a generic exception for when an invalid query parameter is received.","ref":"JSONAPIPlug.Exceptions.InvalidQuery.html","title":"JSONAPIPlug.Exceptions.InvalidQuery","type":"exception"},{"doc":"Server library to build JSON:API compliant REST APIs.","ref":"readme.html","title":"JSON:API library for Plug and Phoenix applications","type":"extras"},{"doc":"This library currently implements version 1.0 of the JSON:API specification.","ref":"readme.html#json-api-support","title":"JSON:API library for Plug and Phoenix applications - JSON:API Support","type":"extras"},{"doc":"Full docs here JSON API Specification (v1.0)","ref":"readme.html#documentation","title":"JSON:API library for Plug and Phoenix applications - Documentation","type":"extras"},{"doc":"Installation Add the following line to your mix.deps file with the desired version to install jsonapi_plug . defp deps do [ ... { :jsonapi_plug , &quot;~&gt; 1.0&quot; } ... ] Configuration You start by declaring one or more APIs. APIs are collections of endpoints that share a common configuration: defmodule MyApp.API do use JSONAPIPlug.API , otp_app : :my_app end See the JSONAPIPlug.API module documentation to learn how to customize your APIs via application configuration of your app. Receiving requests In order to parse JSON:API requests from clients you need to add the JSONAPIPlug.Plug plug to each of your plug pipelines or phoenix controllers handling requests for a specific resource: defmodule MyApp.PostsController do ... plug JSONAPIPlug.Plug , api : MyApp.API , resource : MyApp.PostResource ... end This will take care of ensuring JSON:API specification compliance and will return errors for invalid requests. The :api option expects a module using JSONAPI.API for configuration. The :resource option expects a module using JSONAPIPlug.Resource to convert to/from JSON:API format. When requests are processed, the :jsonapi_plug connection private field is populated with the parsed request. See the JSONAPIPlug.Plug module documentation for usage and options. Serving responses To start serving responses, you need to have some data to return to clients: defmodule MyApp.Post do @type t :: % __MODULE__ { id : pos_integer ( ) , body : String . t ( ) , title : String . t ( ) } @enforce_keys [ :id , :body , :title ] defstruct [ :id , :body , :title ] end and define a resource module to render your resource: defmodule MyApp.PostResource do use JSONAPIPlug.Resource , type : &quot;post&quot; , attributes : [ title : nil , text : nil , excerpt : [ serialize : fn % Post { } = post , _conn -&gt; String . slice ( post . body , 0 .. 5 ) end ] ] @impl JSONAPIPlug.Resource def meta ( % Post { } = post , _conn ) , do : %{ slug : to_slug ( post . title ) } end To use the resource module in Phoenix, just call render and pass the data from your controller: defmodule MyAppWeb.PostsController do ... plug JSONAPIPlug.Plug , api : MyApp.API , resource : MyApp.PostResource ... def create ( % Conn { private : %{ jsonapi_plug : jsonapi_plug } } = conn , params ) do post = ... create a post using jsonapi_plug parsed parameters ... render ( conn , &quot;create.json&quot; , %{ data : post } ) end def index ( % Conn { private : %{ jsonapi_plug : jsonapi_plug } } = conn , _params ) do posts = ... load data using jsonapi_plug parsed parameters ... render ( conn , &quot;index.json&quot; , %{ data : posts } ) end def show ( % Conn { private : %{ jsonapi_plug : jsonapi_plug } = conn , _params ) do post = ... load data using jsonapi_plug parsed parameters ... render ( conn , &quot;show.json&quot; , %{ data : post } ) end def udate ( % Conn { private : %{ jsonapi_plug : jsonapi_plug } } = conn , params ) do post = ... update a post using jsonapi_plug parsed parameters ... render ( conn , &quot;update.json&quot; , %{ data : post } ) end end If you have a Plug application, you can call JSONAPIPlug.Resource.render/5 to generate a JSONAPI.Document with your data for the client. The structure is serializable to JSON with Jason . See the JSONAPIPlug.Plug and JSONAPIPlug.Resource modules documentation for more information.","ref":"readme.html#quickstart","title":"JSON:API library for Plug and Phoenix applications - Quickstart","type":"extras"},{"doc":"This project was born as a fork of the jsonapi library but has since been completely rewritten and is now a completely different project. PRs for new features, bug fixes, documentation and tests are welcome If you are proposing a large feature or change, please open an issue for discussion","ref":"readme.html#contributing","title":"JSON:API library for Plug and Phoenix applications - Contributing","type":"extras"}]